# set default variables for all Makefiles here
# We do not want to have /bin/sh called by accident, so we set this explicitly
# to match the command line shell
SHELL=/bin/bash
export SHELL

# We create a list of subjects
# $(wildcard sub???) produces the same thing as $(ls -d sub???); that is
# a list of all the directories in the pwd that have three characters following
# 'sub'.
SUBJECTS=$(wildcard sub???)

# We have to tell make that nothing is produced by the SUBJECT recipes, and
# the all recipe, which is just all the SUBJECTS.
.PHONY: all $(SUBJECTS)

# You should always define what the all target is to prevent accidents
all: $(SUBJECTS)

# You will be wise to include the definitions of the ugly variables in each
# Makefile. Additionally, other obscure syntax should be explicated in each
# file.  At some point, you will have new people reading these, and this is
# for them; you will also forget what the arbitrary sequences of punctuation
# mean, so helping others is also helping yourself.

# Ugly variable definitions
#    $@ is the filename of the target

# The SUBJECTS rule produces text to tell you which subject is being processed
# and otherwise it changes to the subject directory and makes whatever target
# was specified when you ran make with this Makefile.
$(SUBJECTS):
	@echo
	@echo "==========> Subject is $@"
	@echo
	$(MAKE) --directory=$@ $(TARGET)
